/*
 * genpi.c
 * 
 * Copyright 2023 Reinhard <reinhard@reinhard-TUXEDO>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */
/////////////// HOW TO BUILD ///////////////////
//   flexspin -2 -Wall -DPROPELLER2 genpi.c _complex.c 
///////////////////////////////////////////////////
#include <stdio.h>
#include "_complex.h"
#ifdef PROPELLER2
	#include <propeller2.h>
	// SMARTPINS
	#define CH1  0 // Oszi X
	#define CH2  2 // Oszi Y
	int dac0=0x4000,dac1=0x4000;

    void pinconfig(int pin, int mode, int x, int y)
    {
    _dirl(pin);
    _wrpin(pin,mode);
    _wxpin(pin,x);
    _wypin(pin,y);
    _pinl(pin);
    }
#endif

//////////////////////////////////////////////////////////////////////
// Evaluate the mandelbrotset at the point -0.75 + epsilon approaches pi //
//////////////////////////////////////////////////////////////////////
void demo1 ()
{
	double epsilon = 0.001;
	_complex_t  C = CSET(-0.75,epsilon);
	_complex_t  Z = CSET(0.0,0.0);
	int n = 0;
	while(1)
	{
		Z = CADD(C,CMUL(Z,Z));      // Z <- Z*Z+C
		if(CABS(Z) > 2.0)  break;
		n++;
		_pinnot(0);
	}
	printf("%d %f \n",n,(double) (n * epsilon) );
}

int main()
{
	_waitms(500); // terminal ready ?
	_pinl(0);
	demo1();
	return 0;
}
