/////////////// HOW TO BUILD ///////////////////
//   flexspin -2 -Wall -DPROPELLER2 numeric_testbench.c _complex.c 
///////////////////////////////////////////////////

#include <stdio.h>
#include "_complex.h"

void main()
{
		_waitms(500); //Terminal ready
		// polar2complex
		double r = 1.0;
		double phi = M_PI;
		_complex_t Z,expected;
		
		Z = _polar2complex(r,phi);
		expected = CSET(-1.0,0.0);
		if(0 == _complex_equal(Z,expected)) printf("PASS\n"); else printf("TC1 FAIL\n");
		
		Z = _polar2complex(r,phi/4.0);
		expected = CSET(0.7071,0.7071);
		if(0 == _complex_equal(Z,expected) )printf("PASS\n"); else printf("TC2 FAIL\n");
		
		// conj
		Z = CONJ(Z);
		expected = CSET(0.7071,-0.7071);
		if(0 == _complex_equal(Z,expected)) printf("PASS\n"); else printf("TC3 FAIL\n");
		
		// muld
		Z = CMULD(Z,sqrt(2.0)); 
		expected = CSET(1.0,-1.0);
		if(0 == _complex_equal(Z,expected)) printf("PASS\n"); else printf("TC4 FAIL\n");
		
		// div
		_complex_t ONE = CSET(1.0,0.0);
		Z = CDIV(ONE,Z);
		expected = CSET(0.5000,0.5000);
		if(0 == _complex_equal(Z,expected)) printf("PASS\n"); else printf("TC5 FAIL\n");
		
		// exp
		Z = CEXP(Z); 
		expected = CSET(1.4469 , 0.790439);
		if(0 == _complex_equal(Z,expected)) printf("PASS\n"); else printf("TC6 FAIL\n");
		
		// sum of products Z = A + B*C
		// (2+2*i) + ((1-i)*(1+i)) =  4 + 2i
		_complex_t I = CSET(0.0,1.0);
		_complex_t B = CSUB(ONE,I);
		_complex_t C = CADD(ONE,I);
		_complex_t A = CSET(2.0,2.0);
		Z = CADD(A,CMUL(B,C));
		expected = CSET(4.0,2.0);
		if(0 == _complex_equal(Z,expected)) printf("PASS\n"); else printf("TC7 FAIL\n");
		
}
