/*
 * unity_circle.c
 * 
 * Copyright 2023 Reinhard <reinhard@reinhard-TUXEDO>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */

/////////////// HOW TO BUILD ///////////////////
//   flexspin -2 -Wall -DPROPELLER2 unity_circle.c _complex.c 
///////////////////////////////////////////////////
#include <stdio.h>
#include "_complex.h"
#ifdef PROPELLER2
	#include <propeller2.h>
	// SMARTPINS
	#define CH1  0 // Oszi X
	#define CH2  2 // Oszi Y
	int dac0=0x4000,dac1=0x4000;

    void pinconfig(int pin, int mode, int x, int y)
    {
    _dirl(pin);
    _wrpin(pin,mode);
    _wxpin(pin,x);
    _wypin(pin,y);
    _pinl(pin);
    }
#endif

///////////////////////////////////////////////////////////////
//             unity circle on scope                         //
///////////////////////////////////////////////////////////////
void demo5()
{
    _complex_t z;
    _complex_t  I =  CSET(0.0,1.0);
    int dac0,dac1;
    printf("demo5  unity circle on scope \n");
    printf("Re -> CH1  Im -> CH2 \n");
LOOP:
    for (double phi = 0.0; phi <= 2.0 * M_PI; phi += M_PI / 360.0)
    {
        z = CEXP(CMULD(I,phi));
        dac0 = (int) ( (z.re * 32768/2) + 32768);
        dac1 = (int) ( (z.im * 32768/2) + 32768);
#ifdef PROPELLER2
	_wypin(CH1,dac0);
	_wypin(CH2,dac1);
#endif
        //printf("phi = %f  real = %f   imag = %f\n",phi,z.re,z.im);
}
goto LOOP;

}

int main()
{
#ifdef PROPELLER2
    pinconfig(CH1, 0b101000000000001000100, 1, dac0);  // DAC16bit dither
    _waitms(500);
    pinconfig(CH2, 0b101000000000001000100, 1, dac1);  // DAC16bit dither
    _waitms(500);
#endif	
	demo5();
	return 0;
}
